#!/bin/bash
#
#set -x

echo ""
echo ""
echo "******************** IMPORTANT *************************"
echo "********************************************************"
echo "** DO NOT CUT OFF the main AC power of bullion server **"
echo "** during the Firmware update                         **"
echo "** the server MUST BE IN 'STANDBY' MODE (= POWER OFF) **"
echo "********************************************************"
echo ""
nbparam=$#
if [ $nbparam -ne 4 ] ; then 
echo "==============================================================================="
echo "Command usage: upgradeFW.sh  BMC_IP@    user    password   PhysicalModuleNumber"
echo "Example : upgradeFW.sh 10.10.10.1  super  pass 0"
echo "==============================================================================="
	exit 1
fi

echo "===================================================="
echo "============   Start update of BMC    =============="
echo "===================================================="

echo "************* The current version is : *************" 
./ipmitool -H $1 -U $2 -P $3 bulloem ver BMC $4 > resu$4
cat resu$4
grep 11.15.0 resu$4 > /dev/null
ret_cmd=$?
if [ $ret_cmd -ne 0 ] ; then

./ipmitool -H $1 -U $2 -P $3 bulloem upgrade ./EMM/fw-wub-wpcm450_bulldc_MESCA_111500_1212.bin BMC $4
ret_cmd=$?
if [ $ret_cmd -ne 0 ] ; then
echo ""
echo "**************************************************"
echo "* An error has occured, check the messages above *"
echo "* The firmware upgrade is not fully completed    *"
echo "**************************************************"
echo ""
	exit 1
fi

else
echo "============  No need to update BMC  =============="
	exit 1
fi

echo "===================================================="
echo "=============    End update of BMC     ============="
echo "===================================================="
echo ""
./ipmitool -H $1 -U $2 -P $3 bmc reset cold >> resu$4
echo "************************************************"
echo "***      Automatic BMC reset started.        ***"
echo "***    Please wait a few minutes before      ***"
echo "*** to reconnect the System Hardware Console ***"
echo "************************************************"


